import Canvas from '../references/canvas.js';


class FlourishCanvas extends Canvas {
  Options = null;
  Debug = false;

  XPos = -1


  constructor(el) {
    super(el);
  }


  get HeaderHeight() {
    const a = this;

    return a.Options.HeaderRow.Height[0] + a.Options.HeaderRow.Height[1];
  }


  Load() {
    const a = this;

    a.el.addEventListener('mousemove', function (e) {
      // Hottracking
      if (a.Options.EnableHotTracking) {
        const point = { X: e.offsetX, Y: e.offsetY };

        if (a.Debug) {
          console.log(point);
        }

        a.XPos = point.X;

        a.Invalidate();
      }

    });

    a.el.addEventListener('mouseout', function (e) {
      a.XPos = -1;

      a.Invalidate();
    });

  }

  Invalidate() {
    const a = this;

    if (a.Options == null) {
      return;
    }

    a.Clear();

    if (a.XPos < 0) {
      return;
    }

    a.#drawVerticalLine(a.XPos);
  }

  #drawVerticalLine(x) {
    const a = this;
    const h = this.Height - a.HeaderHeight;

    if (a.Options.HotTrackLine.Width > 1) {
      x += Math.half(a.Options.HotTrackLine.Width);
    }

    a.DrawVerticalLine(x, a.HeaderHeight, h, a.Options.HotTrackLine.Colour, { LineWidth: a.Options.HotTrackLine.Width });
  }

}


export default FlourishCanvas;